

%function [d11,ex11,d12,ex12,d21,ex21,d22,ex22,v11,v12,v21,v22,slopeall,interceptall,slopeallortho,interceptallortho,vardir,alpha1best,alpha2best,beta1best,beta2best]=PickEx(Distance1,var1,Distance2,var2,BoundaryMin,BoundaryMax,linlog1,linlog2,invornot,alpha1,alpha2,beta1,beta2,findbest,WLength1,WLength2,cororlag)
function [da1,exa1,da2,exa2,va1,va2,slopeall,interceptall,slopeallortho,interceptallortho]=InterpDis(Distance1,var1,Distance2,var2,BoundaryMin,BoundaryMax,linlog1,linlog2,d11,ex11,v11,d12,ex12,v12,d21,ex21,v21,d22,ex22,v22)

% (Distance1(ex11)-d11)'
% (Distance2(ex12)-d12)'
% (Distance1(ex21)-d21)'
% (Distance2(ex22)-d22)'

ex1=[ex11;ex21];d1=[d11;d21];ex2=[ex12;ex22];d2=[d12;d22];v1=[v11;v21];v2=[v12;v22];
temp=sortrows([ex1 d1 v1 ex2 d2 v2],2);
ex1=temp(:,1);
d1=temp(:,2);
v1=temp(:,3);
ex2=temp(:,4);
d2=temp(:,5);
v2=temp(:,6);
clear temp;


temp2=sortrows([ex1 d1 v1 ex2 d2 v2],5);
bex1=temp2(:,1);
bd1=temp2(:,2);
bv1=temp2(:,3);
bex2=temp2(:,4);
bd2=temp2(:,5);
bv2=temp2(:,6);
clear temp2;

DelReverse=(setdiff(1:length(d1),sort([find(diff(ex2)'<0) find(diff(ex2)'<0)+1])))';
display([num2str(length(find(diff(ex2)'<0))) ' distance reversals suppressed (' num2str(2*length(find(diff(ex2)'<0))) ' points suppressed).']);

% [bex1 bex2]'
% diff([bex1 bex2])'

% DelReverse2=(setdiff(1:length(bd2),sort([find(diff(bex1)'<0) find(diff(bex1)'<0)+1])))';
% display([num2str(length(find(diff(bex1)'<0))) ' distance reversals not suppressed (' num2str(2*length(find(diff(bex1)'<0))) ' points not suppressed).']);
% 
% sort([find(diff(ex2)'<0) find(diff(ex2)'<0)+1])
% sort([find(diff(bex1)'<0) find(diff(bex1)'<0)+1])

ex1=ex1(DelReverse);
d1=d1(DelReverse);
v1=v1(DelReverse);
ex2=ex2(DelReverse);
d2=d2(DelReverse);
v2=v2(DelReverse);



% da11=0;exa11=0;da12=0;exa12=0;da21=0;exa21=0;da22=0;exa22=0;va11=0;va12=0;va21=0;va22=0;slopeall=0;interceptall=0;slopeallortho=0;interceptallortho=0;

var1all=var1;Distance1all=Distance1;
var2all=var2;Distance2all=Distance2;

toaddindex1=0;
toaddindex2=0;

if BoundaryMin>0
    min1=min(find(Distance1>=BoundaryMin));
    min2=min(find(Distance2>=BoundaryMin));
    var1=var1(min1:end);
    var2=var2(min2:end);
    Distance1=Distance1(min1:end);
    Distance2=Distance2(min2:end);
    toaddindex1=min1-1;
    toaddindex2=min2-1;
end
if (BoundaryMax>0)%&&(BoundaryMin>0)
    max1=max(find(Distance1<=BoundaryMax));
    max2=max(find(Distance2<=BoundaryMax));
    var1=var1(1:max1);
    var2=var2(1:max2);
    Distance1=Distance1(1:max1);
    Distance2=Distance2(1:max2);
end

var1ori=var1;l1=length(var1);
var2ori=var2;l2=length(var2);

ex1=ex1-toaddindex1;
ex2=ex2-toaddindex1;
% [toaddindex1 toaddindex2]

% [size(ex11);size(d11);size(ex12);size(d12);
% size(ex21);size(d21);size(ex22);size(d22)]

length(ex1);
length(ex2);

numinterv=length(ex1)-1;

comb=min(diff([ex1 ex2])')';
comb(end)=1+comb(end);
lengcomb=sum(comb);
cumcomb=[0;cumsum(comb)];


da1=zeros(lengcomb,1);
exa1=zeros(lengcomb,1);
da2=zeros(lengcomb,1);
exa2=zeros(lengcomb,1);
va1=zeros(lengcomb,1);
va2=zeros(lengcomb,1);

for i=1:numinterv
    %     i
%     [cumcomb(i)+1 cumcomb(i+1);
%     ex1(i) ex1(i+1);
%     ex2(i) ex2(i+1)]
    currentint1=(ex1(i):ex1(i+1))';l1=length(currentint1);
    currentint2=(ex2(i):ex2(i+1))';l2=length(currentint2);
    currentdis1=Distance1(currentint1);
    currentdis2=Distance2(currentint2);
    mindis1=Distance1(ex1(i));maxdis1=Distance1(ex1(i+1));
    mindis2=Distance2(ex2(i));maxdis2=Distance2(ex2(i+1));
    if l1==l2
        if i==numinterv
            l1=l1+1;l2=l2+1;
        end
        da1(cumcomb(i)+1:cumcomb(i+1))=currentdis1(1:l1-1);
        da2(cumcomb(i)+1:cumcomb(i+1))=currentdis2(1:l1-1);
        exa1(cumcomb(i)+1:cumcomb(i+1))=currentint1(1:l1-1);
        exa2(cumcomb(i)+1:cumcomb(i+1))=currentint2(1:l1-1);
        va1(cumcomb(i)+1:cumcomb(i+1))=var1(currentint1(1:l1-1));
        va2(cumcomb(i)+1:cumcomb(i+1))=var2(currentint2(1:l1-1));
    elseif l1<l2
        difdis=abs((linspace(mindis2,maxdis2,l1)')*ones(1,length(currentdis2))-ones(length(currentint1),1)*currentdis2');
        mindis=zeros(1,l1);
        for j=1:l1
            temp=find(difdis(j,:)==min(difdis(j,:)));
            if length(temp)==1
                mindis(j)=temp;
            else
                mindis(j)=temp(1);
            end
        end
        if i==numinterv
            l1=l1+1;l2=l2+1;
        end
%         i
%         size(cumcomb(i)+1:cumcomb(i+1))
%         size(1:l1-1)
        da1(cumcomb(i)+1:cumcomb(i+1))=currentdis1(1:l1-1);
        da2(cumcomb(i)+1:cumcomb(i+1))=currentdis2(mindis(1:l1-1));
        exa1(cumcomb(i)+1:cumcomb(i+1))=currentint1(1:l1-1);
        exa2(cumcomb(i)+1:cumcomb(i+1))=currentint2(mindis(1:l1-1));
        va1(cumcomb(i)+1:cumcomb(i+1))=var1(currentint1(1:l1-1));
        va2(cumcomb(i)+1:cumcomb(i+1))=var2(currentint2(mindis(1:l1-1)));
    else
        difdis=abs(currentdis1*ones(1,length(currentdis2))-ones(length(currentdis1),1)*linspace(mindis1,maxdis1,l2));
        mindis=zeros(1,l2);
        for j=1:l2
            temp=find(difdis(:,j)==min(difdis(:,j)));
            if length(temp)==1
                mindis(j)=temp;
            else
                mindis(j)=temp(1);
            end
        end
        if i==numinterv
            l1=l1+1;l2=l2+1;
        end
        da1(cumcomb(i)+1:cumcomb(i+1))=currentdis1(mindis(1:l2-1));
        da2(cumcomb(i)+1:cumcomb(i+1))=currentdis2(1:l2-1);
        exa1(cumcomb(i)+1:cumcomb(i+1))=currentint1(mindis(1:l2-1));
        exa2(cumcomb(i)+1:cumcomb(i+1))=currentint2(1:l2-1);
        va1(cumcomb(i)+1:cumcomb(i+1))=var1(currentint1(mindis(1:l2-1)));
        va2(cumcomb(i)+1:cumcomb(i+1))=var2(currentint2(1:l2-1));
    end
%     find(ismember(va1,v1(i)))
end
% % size()
% % size()
% % size()
% % size()
% [va1(cumcomb(1:end-1)+1)-var1(ex1(1:end-1)) va2(cumcomb(1:end-1)+1)-var2(ex2(1:end-1))]

va1log=log10(abs(va1));
va2log=log10(abs(va2));
okpoint=intersect(find(~isnan(va1log)),find(~isnan(va2log)));
union(find(isnan(va1log)),find(isnan(va2log)));
va1log=va1log(okpoint);
va2log=va2log(okpoint);

if linlog1&&linlog2
    [P,S]=polyfit(va1log,va2log,1);
    [Portho,Sortho,~]=OrthoFit(va1log,va2log);
    slopeall=P(1);
    interceptall=10^(P(2));
    slopeallortho=Portho;
    interceptallortho=10^Sortho;
    display(['Least-square fit var2=f(var1): var2= ' num2str(rounddec(interceptall,2)) ' x var1 ^{' num2str(rounddec(slopeall,2)) '}.']);
    display(['Orthogonal least-square fit var2=f(var1): var2= ' num2str(rounddec(interceptallortho,2)) ' x var1 ^{' num2str(rounddec(slopeallortho,2)) '}.']);
elseif linlog1&&~linlog2%var2=alpha*log10(var1)+beta;
    [P,S]=polyfit(va1log,var2all,1);
    [Portho,Sortho,~]=OrthoFit(va1log,var2all);
    slopeall=P(1);
    interceptall=P(2);
    slopeallortho=Portho;
    interceptallortho=Sortho;
    display(['Least-square fit var2=f(var1): var2= ' num2str(rounddec(slopeall,2)) ' x log_{10}(var1) + ' num2str(rounddec(interceptall,2)) '.']);
    display(['Orthogonal least-square fit var2=f(var1): var2= ' num2str(rounddec(slopeallortho,2)) ' x log_{10}(var1} +' num2str(rounddec(interceptallortho,2)) '.']);
elseif linlog2&&~linlog1%var2=10^(alpha*var1)* 10^beta;
    [P,S]=polyfit(var1all,va2log,1);
    [Portho,Sortho,~]=OrthoFit(var1all,va2log);
    slopeall=P(1);
    interceptall=10^(P(2));
    slopeallortho=Portho;
    interceptallortho=10^Sortho;
    display(['Least-square fit var2=f(var1): var2= ' num2str(rounddec(interceptall,2)) ' x var1 ^{' num2str(rounddec(slopeall,2)) '}.']);
    display(['Orthogonal least-square fit var2=f(var1): var2= ' num2str(rounddec(interceptallortho,2)) ' x var1 ^{' num2str(rounddec(slopeallortho,2)) '}.']);
else
    [P,S]=polyfit(var1all,var2all,1);
    [Portho,Sortho,~]=OrthoFit(var1all,var2all);
    slopeall=P(1);
    interceptall=P(2);
    slopeallortho=Portho;
    interceptallortho=Sortho;
    display(['Least-square fit var2=f(var1): var2= ' num2str(rounddec(slopeall,2)) ' x var1 + ' num2str(rounddec(interceptall,2)) '.']);
    display(['Orthogonal least-square fit var2=f(var1): var2= ' num2str(rounddec(slopeallortho,2)) ' x var1 +' num2str(rounddec(interceptallortho,2)) '.']);
end

function [xround]=rounddec(x,prec)
xround=real(round((10^(prec-floor(log10(x)))*x))/(10^(prec-floor(log10(x)))));%real to avoid numerical errors that cause imaginary values...


% (Distance1all(ex21)-d21)'
% (Distance2all(ex22)-d22)'
% (Distance1all(ex21)-d21)'
% (Distance2all(ex22)-d22)'