%Ricker wavelet

function [window]=ricker(L);

if L==1
    window=1;
else
    x=linspace(-1,1,L);%Window size of L points
    window=(1-(1+(L-1)/4)*x.^2).*exp(-(pi*x).^2);
    window=window/sum(window);%normalize window to avoid shrinking the dataset...
end
window=window';